commit 1f6e24e73ccdca64864da009a21f5b7051d200a1
Author: bellard <bellard@c046a42c-6fe2-441c-8c8c-71466251a162>
Date:   Mon Jun 26 21:00:51 2006 +0000

    display device identifier string for user with info usb (Lonnie Mendez)
    
    
    git-svn-id: svn://svn.savannah.nongnu.org/qemu/trunk@2029 c046a42c-6fe2-441c-8c8c-71466251a162

diff --git a/hw/usb-hid.c b/hw/usb-hid.c
index 883befc..93f46db 100644
--- a/hw/usb-hid.c
+++ b/hw/usb-hid.c
@@ -521,6 +521,8 @@ USBDevice *usb_tablet_init(void)
     s->dev.handle_data = usb_mouse_handle_data;
     s->kind = USB_TABLET;
 
+    pstrcpy(s->dev.devname, sizeof(s->dev.devname), "QEMU USB Tablet");
+
     return (USBDevice *)s;
 }
 
@@ -539,5 +541,7 @@ USBDevice *usb_mouse_init(void)
     s->dev.handle_data = usb_mouse_handle_data;
     s->kind = USB_MOUSE;
 
+    pstrcpy(s->dev.devname, sizeof(s->dev.devname), "QEMU USB Mouse");
+
     return (USBDevice *)s;
 }
diff --git a/hw/usb-hub.c b/hw/usb-hub.c
index c69d69c..2eba905 100644
--- a/hw/usb-hub.c
+++ b/hw/usb-hub.c
@@ -544,6 +544,8 @@ USBDevice *usb_hub_init(int nb_ports)
     s->dev.handle_control = usb_hub_handle_control;
     s->dev.handle_data = usb_hub_handle_data;
 
+    pstrcpy(s->dev.devname, sizeof(s->dev.devname), "QEMU USB Hub");
+
     s->nb_ports = nb_ports;
     for(i = 0; i < s->nb_ports; i++) {
         port = &s->ports[i];
diff --git a/hw/usb-msd.c b/hw/usb-msd.c
index bcca6d4..3dccfb9 100644
--- a/hw/usb-msd.c
+++ b/hw/usb-msd.c
@@ -389,6 +389,9 @@ USBDevice *usb_msd_init(const char *filename)
     s->dev.handle_control = usb_msd_handle_control;
     s->dev.handle_data = usb_msd_handle_data;
 
+    snprintf(s->dev.devname, sizeof(s->dev.devname), "QEMU USB MSD(%.16s)",
+             filename);
+
     s->scsi_dev = scsi_disk_init(bdrv, usb_msd_command_complete, s);
     usb_msd_handle_reset((USBDevice *)s, 0);
     return (USBDevice *)s;
diff --git a/hw/usb.h b/hw/usb.h
index abdbb45..b0887d6 100644
--- a/hw/usb.h
+++ b/hw/usb.h
@@ -128,6 +128,7 @@ struct USBDevice {
     int (*handle_data)(USBDevice *dev, int pid, uint8_t devep,
                        uint8_t *data, int len);
     uint8_t addr;
+    char devname[32];
     
     int state;
     uint8_t setup_buf[8];
diff --git a/usb-linux.c b/usb-linux.c
index 8009a1b..aa1ded2 100644
--- a/usb-linux.c
+++ b/usb-linux.c
@@ -44,11 +44,13 @@ typedef int USBScanFunc(void *opaque, int bus_num, int addr, int class_id,
                         int vendor_id, int product_id, 
                         const char *product_name, int speed);
 static int usb_host_find_device(int *pbus_num, int *paddr, 
+                                char *product_name, int product_name_size,
                                 const char *devname);
 
 //#define DEBUG
 
 #define USBDEVFS_PATH "/proc/bus/usb"
+#define PRODUCT_NAME_SZ 32
 
 typedef struct USBHostDevice {
     USBDevice dev;
@@ -145,8 +147,11 @@ USBDevice *usb_host_device_open(const char *devname)
     char buf[1024];
     int descr_len, dev_descr_len, config_descr_len, nb_interfaces;
     int bus_num, addr;
+    char product_name[PRODUCT_NAME_SZ];
 
-    if (usb_host_find_device(&bus_num, &addr, devname) < 0) 
+    if (usb_host_find_device(&bus_num, &addr, 
+                             product_name, sizeof(product_name),
+                             devname) < 0) 
         return NULL;
     
     snprintf(buf, sizeof(buf), USBDEVFS_PATH "/%03d/%03d", 
@@ -230,6 +235,14 @@ USBDevice *usb_host_device_open(const char *devname)
     dev->dev.handle_reset = usb_host_handle_reset;
     dev->dev.handle_control = usb_host_handle_control;
     dev->dev.handle_data = usb_host_handle_data;
+
+    if (product_name[0] == '\0')
+        snprintf(dev->dev.devname, sizeof(dev->dev.devname),
+                 "host:%s", devname);
+    else
+        pstrcpy(dev->dev.devname, sizeof(dev->dev.devname),
+                product_name);
+
     return (USBDevice *)dev;
 }
 
@@ -337,6 +350,7 @@ typedef struct FindDeviceState {
     int product_id;
     int bus_num;
     int addr;
+    char product_name[PRODUCT_NAME_SZ];
 } FindDeviceState;
 
 static int usb_host_find_device_scan(void *opaque, int bus_num, int addr, 
@@ -345,8 +359,11 @@ static int usb_host_find_device_scan(void *opaque, int bus_num, int addr,
                                      const char *product_name, int speed)
 {
     FindDeviceState *s = opaque;
-    if (vendor_id == s->vendor_id &&
-        product_id == s->product_id) {
+    if ((vendor_id == s->vendor_id &&
+        product_id == s->product_id) ||
+        (bus_num == s->bus_num &&
+        addr == s->addr)) {
+        pstrcpy(s->product_name, PRODUCT_NAME_SZ, product_name);
         s->bus_num = bus_num;
         s->addr = addr;
         return 1;
@@ -359,6 +376,7 @@ static int usb_host_find_device_scan(void *opaque, int bus_num, int addr,
    'bus.addr' (decimal numbers) or 
    'vendor_id:product_id' (hexa numbers) */
 static int usb_host_find_device(int *pbus_num, int *paddr, 
+                                char *product_name, int product_name_size,
                                 const char *devname)
 {
     const char *p;
@@ -369,6 +387,11 @@ static int usb_host_find_device(int *pbus_num, int *paddr,
     if (p) {
         *pbus_num = strtoul(devname, NULL, 0);
         *paddr = strtoul(p + 1, NULL, 0);
+        fs.bus_num = *pbus_num;
+        fs.addr = *paddr;
+        ret = usb_host_scan(&fs, usb_host_find_device_scan);
+        if (ret)
+            pstrcpy(product_name, product_name_size, fs.product_name);
         return 0;
     }
     p = strchr(devname, ':');
@@ -379,6 +402,7 @@ static int usb_host_find_device(int *pbus_num, int *paddr,
         if (ret) {
             *pbus_num = fs.bus_num;
             *paddr = fs.addr;
+            pstrcpy(product_name, product_name_size, fs.product_name);
             return 0;
         }
     }
diff --git a/vl.c b/vl.c
index b01c9b3..d5a0f7b 100644
--- a/vl.c
+++ b/vl.c
@@ -3785,8 +3785,8 @@ void usb_info(void)
             speed_str = "?"; 
             break;
         }
-        term_printf("  Device %d.%d, speed %s Mb/s\n", 
-                    0, dev->addr, speed_str);
+        term_printf("  Device %d.%d, Speed %s Mb/s, Product %s\n", 
+                    0, dev->addr, speed_str, dev->devname);
     }
 }
 
